#include <iostream>
#define TY __typeof
#define SZ size()
#define PB push_back
#define MP make_pair
#define FOR(i,x,n) for(TY(x) i=(x); i!=(n); i++)
#define FRD(i,  n) for(TY(n) i=(n); i--!=0; )
#define FR( i,n)   FOR(i,0,n)
#define FRI(it,v)  FOR(it,v.begin(),v.end())
#define WRA(a,n)   { cerr << #a << " = "; \
		     FR(z,n) cerr << a[z] << ((z==(n)-1)? '\n':' '); }
#define WR( x)     cerr << #x << /*":@" << __LINE__ <<*/ " = " <<  (x) << endl 
#define CLR(a,v)   memset((a),(v),sizeof(a))
//#define BE(
using namespace std;

typedef long long LL;
typedef unsigned UN;
typedef pair<int, int> Pr;

const int MAX_N = 1000 + 10;
const string trans = "01----9-86";

string s[MAX_N];
int v[MAX_N];
int n, k;
int c[MAX_N];

bool mirror(string s, string &r) {
  if (s[s.SZ-1] == '0') return false;
  char ch;
  r = s;
  FR(i, (int)r.SZ) {
    if ((ch = trans[r[i]-'0']) == '-')
      return false;
    r[i] = ch;
  }
  reverse(r.begin(), r.end());
  //cerr << "reverse of " << s << " is " << r << endl;
  return true;
}

string tostring (int x) {
  char ch[100];
  sprintf(ch, "%d", x);
  return string(ch);
}

int toint(string s) {
  int x;
  sscanf(s.c_str(), "%d", &x);
  return x;
}

bool add(string s) {
  if (s[0] == '0')
    return false;
  int x = toint(s);
  //WR(x);
  if (x > n)
    return false;
  c[x]++;
  return true;
}

bool istrue() {
  string r;
  memset(c, 0, sizeof c);
  FR(i,k) {
    if (s[i][0] == s[i][s[i].SZ-1] && s[i][0] == '0')
      return false;
    int d = add(s[i]);
    if (mirror(s[i], r)) 
      d += add(r);
    if (d == 0)
      return false;
  }
  //cerr << "!***********************" << endl;
  FOR(i,1,n+1)
    if (c[i] > 1+(mirror(tostring(i), r) && toint(r) <= n))
      return false;
  return true;
}

int main() {
  int testn;
  for (cin >> testn; testn--; ) {
    cin >> n >> k;
    //cerr << n << " " <<k << "!\n";
    FR(i,k)
      cin >> s[i];
    cout << (istrue()?"Calm down, Dude!":"Never trust him, again!") << endl;
  }
  return 0;
}
