#include <cassert>
#include <cctype>
#include <iostream>
#include <stack>
#define TY __typeof
#define SZ size()
#define PB push_back
#define MP make_pair
#define FOR(i,x,n) for(TY(x) i=(x); i!=(n); i++)
#define FRD(i,  n) for(TY(n) i=(n); i--!=0; )
#define FR( i,n)   FOR(i,0,n)
#define FRI(it,v)  FOR(it,v.begin(),v.end())
#define WRA(a,n)   { cerr << #a << " = "; \
		     FR(z,n) cerr << a[z] << ((z==(n)-1)? '\n':' '); }
#define WR( x)     cerr << #x << /*":@" << __LINE__ <<*/ " = " <<  (x) << endl 
#define CLR(a,v)   memset((a),(v),sizeof(a))
//#define BE(
using namespace std;

typedef long long LL;
typedef unsigned UN;
typedef pair<int, int> Pr;

const int MAX_N = 5*1000 + 10;

string s, r, q;
stack<char> st;
bool ism;

int main() {
  int testn;
  for (cin >> testn; testn--; ) {
    cin >> s;
    r = "";
    bool ism = false;
    while (!st.empty()) st.pop();
    FR(i,(int)s.SZ) {
      //WR(i);
      if (s[i] == '(') {
	if (i>0 && s[i-1] == '-')
	  { ism = !ism; st.push('-'); }
	else
	  st.push('+');
      }
      else if (s[i] == ')') {
	assert(!st.empty());
	assert(s[i-1] != '(');
	if (st.top() == '-')
	  ism = !ism;
	st.pop();
      }
      else if (isalpha(s[i])) {
	char ch = s[i];
	if (ism) ch = ch - 'A' + 'a';
	r = r + ch;
      }
      else { // -
	assert(s[i] == '-');
	if (i+1 == (int)s.SZ || s[i+1] != '(')
	  assert(0);
      }
    }
    assert(st.empty());
    q = "";
    if (islower(r[0]))
      q = "-(";
    q += toupper(r[0]);
    FOR(i,1,(int)r.SZ) {
      if (isupper(r[i])){
	if (islower(r[i-1]))
	  q += ")";
      }
      else { // islower(s[i])
	if (isupper(r[i-1]))
	  q += "-(";
      }
      q += toupper(r[i]);
    }
    if (islower(r[r.SZ-1]))
      q += ")";
    if(0) {
      WR(s);
      WR(r);
      WR(q);
      cerr << endl;
    }
    cout << q.SZ << endl;
  }
  return 0;
}

