#include <cmath>
#include <iostream>
#define TY __typeof
#define SZ size()
#define PB push_back
#define MP make_pair
#define FOR(i,x,n) for(TY(x) i=(x); i!=(n); i++)
#define FRD(i,  n) for(TY(n) i=(n); i--!=0; )
#define FR( i,n)   FOR(i,0,n)
#define FRI(it,v)  FOR(it,v.begin(),v.end())
#define WRA(a,n)   { cerr << #a << " = "; \
		     FR(_z,n) cerr << a[_z] << ((_z==(n)-1)? '\n':' '); }
#define WR( x)     cerr << #x << /*":@" << __LINE__ <<*/ " = " <<  (x) << endl 
#define CLR(a,v)   memset((a),(v),sizeof(a))
//#define BE(
using namespace std;

typedef long long LL;
typedef unsigned UN;
typedef pair<LL, LL> Pr;

const int MAX_N = 1*1000 + 10;

struct Event {
  Pr time;
  int m[2];
} e[MAX_N*MAX_N];
int en;

bool operator < (const Event &e1, const Event &e2) {
  if (e1.time.first*e2.time.second != e1.time.second*e2.time.first)
    return (e1.time.first*e2.time.second < e1.time.second*e2.time.first);
  else
    return e1.m[0] < e2.m[0];
}

struct Mice {
  LL x, y, v;
} a[MAX_N];

Event v[MAX_N];
int vn;
bool dead[MAX_N];
int n;
Pr death[MAX_N];

#define sqr(x) ( (x)*(x) )

inline LL dist(int i, int j) {
  return (sqr(a[i].x-a[j].x) + sqr(a[j].y-a[i].y));
}

int main() {
  int testn;
  for (cin >> testn; testn--; ) {
    cin >> n;
    FR(i,n) cin >> a[i].x >> a[i].y >> a[i].v;
    en = 0;
    FR(i,n) FOR(j,i+1,n) {
      e[en].m[0] = i;
      e[en].m[1] = j;
      e[en].time.first = dist(i, j);
      e[en].time.second = sqr(a[i].v + a[j].v);
      en++;
    }
    sort(e, e+en);
    vn = 0;
    CLR(dead, false);
    FR(i,en)
      if ((!dead[e[i].m[0]] || death[e[i].m[0]] == e[i].time)  && 
	  (!dead[e[i].m[1]] || death[e[i].m[1]] == e[i].time))
	FR(j,2)
	  if (!dead[e[i].m[j]]) {
	    dead[e[i].m[j]] = true;
	    death[e[i].m[j]] = e[i].time;
	    v[vn].time = e[i].time;
	    v[vn].m[0] = e[i].m[j];
	    vn++;
	  }
    sort(v, v+vn);
    FR(i,n)
      if (!dead[i]) 
	v[vn++].m[0] = i;
    FR(i,vn)
      cout << 1+v[i].m[0] << " "; cout << endl;
  }
  return 0;
}

