#include <cstdio>
#include <algorithm>
#include <iostream>
using namespace std;
const double eps=1e-9;
struct line{
    int a,b;
    line(){}
    line(int _a,int _b):a(_a),b(_b){}
};
bool operator<(const line& l1,const line& l2){return l1.a<l2.a;}
double inter(const line& l1,const line& l2){
    return double(l2.b-l1.b)/double(l1.a-l2.a);
}
struct alg{
    int n,last_i;
    void reset(){n=last_i=0;}
    line l[100000];
    void push(const line& u){
        while ((n>0 && l[n-1].a==u.a && l[n-1].b<u.b) || (n>1 && inter(l[n-2],l[n-1])>=inter(l[n-2],u)))
            --n;
        if (n==0 || l[n-1].a!=u.a)
		l[n++]=u;
        if (last_i>=n)
            last_i=n-1;
    }
    int val(int nx){
        while (last_i<n-1 && double(nx)>=inter(l[last_i],l[last_i+1]))
            ++last_i;
        return l[last_i].a*nx+l[last_i].b;
    }
};
alg a;
int m,n;
line l[100000];
pair<int,int> t[100000];
int main(){
    int tcou;scanf("%d",&tcou);
    while (tcou--){
        a.reset();
        scanf("%d%d",&m,&n);
        for (int i=0;i<m;++i)
            scanf("%d%d",&l[i].b,&l[i].a);
        for (int i=0;i<n;++i){
            scanf("%d",&t[i].first);
            t[i].second=i;
        }
        sort(l,l+m);
        sort(t,t+n);
        for (int i=0;i<m;++i)
            a.push(l[i]);
        for (int i=0;i<n;++i){
            t[i].first=a.val(t[i].first);
            swap(t[i].first,t[i].second);
        }
        sort(t,t+n);
        for (int i=0;i<n;++i)
            printf("%d%c",t[i].second,i+1==n?'\n':' ');
    }
    return 0;
}
