#include <sstream>
#include <iostream>
#include <set>
#include <vector>
#include <queue>
#define TY __typeof
#define SZ size()
#define PB push_back
#define MP make_pair
#define FOR(i,x,n) for(TY(x) i=(x); i!=(n); i++)
#define FRD(i,  n) for(TY(n) i=(n); i--!=0; )
#define FR( i,n)   FOR(i,0,n)
#define FRI(it,v)  FOR(it,v.begin(),v.end())
#define WRA(a,n)   { cerr << #a << " = "; \
		     FR(z,n) cerr << a[z] << ((z==(n)-1)? '\n':' '); }
#define WR( x)     cerr << #x << /*":@" << __LINE__ <<*/ " = " <<  (x) << endl 
#define CLR(a,v)   memset((a),(v),sizeof(a))
//#define BE(
using namespace std;

typedef long long LL;
typedef unsigned UN;
typedef pair<int, int> Pr;

const int MAX_N = 100 + 13;
int n, l;
typedef multiset<char> S;
S st[MAX_N];
string s[MAX_N];
set<int> reach[MAX_N];
vector<int> adj[MAX_N];
vector<char> res;
string ans;
queue<int> q;
int d[MAX_N];
string par[MAX_N];
string INF(MAX_N*25, '_');

string BFS(int x) {
  CLR(d, -1);
  d[x] = 0;
  par[x] = s[x];
  while (!q.empty()) q.pop();
  for (q.push(x); !q.empty(); q.pop()) {
    int f = q.front();
    FRI(it, adj[f])
      if (d[*it] == -1) {
	d[*it] = d[f] + 1; q.push(*it); par[*it] = par[f] + " " + s[*it];
	if (reach[x].find(*it) != reach[x].end()) 
	  return par[*it];
      }
  }
  return INF;
}

int main() {
  int testn;
  string r;
  for (cin >> testn; testn--; ) {
    cin >> n >> l;
    FR(i,n) cin >> s[i]; 
    sort(s, s+n);
    FR(i,n) { st[i].clear(); FR(j,l) st[i].insert(s[i][j]); }
    res.resize(l);
    FR(i,n) { 
      reach[i].clear();
      adj[i].clear();
      FR(j,n) {
	int common = set_intersection(st[i].begin(), st[i].end(), 
				      st[j].begin(), st[j].end(), res.begin()) - res.begin();
	if (common == l-1)
	  adj[i].PB(j);
	if (common == 0)
	  reach[i].insert(j);
      }
    }

    ans = INF;
    FR(i,n) {
      r = BFS(i);
      if (r.SZ < ans.SZ || (r.SZ == ans.SZ && r < ans))
	ans = r;
    }    
    cout << ans << endl;

  }
  return 0;
}

