//in the name of GOD
#include <iostream>
#include <cstdio>
#include <algorithm>
using namespace std;

struct point{
	int x,y;
	point(int x=0,int y=0) : x(x),y(y) {}
	inline int operator^(const point& p) const{
		return x*p.y-y*p.x;
	}
	inline point operator-(const point& p)const{
		return point(x-p.x,y-p.y);
	}
	bool operator<(const point&)const;
	inline void operator-=(const point& p){
		(*this)=(*this)-p;
	}
} base;

const int maxn=100000;
point p[maxn],pit;
int n;
int st[maxn],ins;

bool point::operator<(const point& p)const{
	return (((*this)-base)^(p-base))>0;
}

void push(int x){
	for (;ins>0; ins--){
		if (((p[st[ins]]-p[st[ins-1]])^(p[x]-p[st[ins-1]]))>0) break;
	}
	st[++ins]=x;
}

int main(){
	int test; scanf("%d",&test);
	while (test--){
		scanf("%d%d%d",&n,&pit.x,&pit.y);
		for (int i=0; i<n; i++)
			scanf("%d%d",&p[i].x,&p[i].y);
		int min=0;
		for (int i=1; i<n; i++)
			if (p[i].y<p[min].y || (p[i].y==p[min].y && p[i].x<p[min].x))
				min=i;
		base=p[min]; p[min]=p[0]; p[0]=base;
		sort(p+1,p+n);
		ins=0; st[0]=0;
		for (int i=1; i<n; i++) push(i);
		bool good=true;
		for (int i=0; i<ins; i++)
			if (((p[st[i+1]]-p[st[i]])^(pit-p[st[i]]))<0){
				good=false; break;
			}
		if (good && ((p[st[0]]-p[st[ins]])^(pit-p[st[ins]]))<0) good=false;
		if (good) printf("YES\n");
		else printf("NO\n");
	}
	return 0;
}
