#include <iostream>
#include <utility>
using namespace std;
int n,m;
int h[100];
int e[5000][3];
int adj[100][100];
int parent[100];
void reset(){for (int i=0;i<n;++i) parent[i]=i;}
int par(int v){
	if (v==parent[v])
		return v;
	return parent[v]=par(parent[v]);
}
bool check(int l,int u){
	reset();
	for (int i=0;i<m;++i)
		if (h[e[i][0]]>=l && h[e[i][0]]<=u && h[e[i][1]]>=l && h[e[i][1]]<=u)
			parent[par(e[i][0])]=par(e[i][1]);
	return par(0)==par(n-1);
}
int bs(int ll,int l,int u){
	if (u<l)
		throw -1;
	if (l==u)
		return l;
	int mid=(l+(long long)u)/2;
	bool res=check(ll,mid);
	if (res)
		return bs(ll,l,mid);
	else
		return bs(ll,mid+1,u);
}
bool marked[100];
int d[100];
int dij(int l,int u){
	memset(marked,0,sizeof(marked));
	for (int i=0;i<n;++i)
		d[i]=1000000000;
	for (int i=0;i<n;++i)
		if (h[i]<l || h[i]>u)
			marked[i]=true;
	int v=0;d[v]=0;
	while (v!=-1 && !marked[v]){
		marked[v]=true;
		for (int i=0;i<n;++i)
			if (!marked[i] && adj[v][i]+d[v]<d[i])
				d[i]=adj[v][i]+d[v];
		v=-1;
		for (int i=0;i<n;++i)
			if (!marked[i] && (v==-1 || d[i]<d[v]))
				v=i;
	}
	return d[n-1];
}
int main(){
	int tcou;cin>>tcou;
	while (tcou--){
		cin>>n>>m;
		for (int i=0;i<n;++i)
			cin>>h[i];
		for (int i=0;i<n;++i)
			for (int j=0;j<n;++j)
				adj[i][j]=(i==j)?0:1000000000;
		for (int i=0;i<m;++i){
			cin>>e[i][0]>>e[i][1]>>e[i][2];--e[i][0];--e[i][1];
			adj[e[i][0]][e[i][1]]=min(adj[e[i][0]][e[i][1]],e[i][2]);
			adj[e[i][1]][e[i][0]]=min(adj[e[i][1]][e[i][0]],e[i][2]);
		}
		pair<int,int> ans(1000000001,0);
		for (int i=0;i<n;++i){
			int l=h[i];
			int u=bs(l,l,l+1000000000);
			if (u>=1000000000)
				continue;
			ans=min(ans,make_pair(u-l,dij(l,u)));
		}
		cout<<ans.first<<' '<<ans.second<<endl;
	}
	return 0;
}
